var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";
import styled, { keyframes } from "react-emotion";
import { Tab, Tabs } from "./Tabs";
import Post from "./Post";
import { ThemeProvider } from "emotion-theming";

import theme from "../utils/theme";

var ring = /*#__PURE__*/keyframes("0%{transform:rotate(0deg);}100%{transform:rotate(360deg);}");

var Loading = /*#__PURE__*/styled("div", {
  target: "e1tz1q3f0"
})("display:block;position:relative;width:64px;height:64px;margin:60px auto;div{box-sizing:border-box;display:block;position:absolute;width:51px;height:51px;margin:6px;border:6px solid #fff;border-radius:50%;animation:", ring, " 1.2s cubic-bezier(0.5,0,0.5,1) infinite;border-color:", function (p) {
  return p.theme.gray2;
}, " transparent transparent transparent;}div:nth-child(1){animation-delay:-0.45s;}div:nth-child(2){animation-delay:-0.3s;}div:nth-child(3){animation-delay:-0.15s;}");

var PostsWrapper = /*#__PURE__*/styled("div", {
  target: "e1tz1q3f1"
})("display:flex;flex-direction:column;min-height:100%;");

var Timeline = /*#__PURE__*/styled("div", {
  target: "e1tz1q3f2"
})("flex:1;padding:0 25px;margin-top:30px;margin-bottom:30px;position:relative;&:before{position:absolute;content:\"\";display:block;left:24px;width:1px;top:2px;bottom:0;background:", function (p) {
  return p.theme.borderLight;
}, ";}");

var FIREBASE_FUNCTION = "https://us-central1-changepane.cloudfunctions.net/posts/";

var Posts = function (_React$Component) {
  _inherits(Posts, _React$Component);

  function Posts(props) {
    _classCallCheck(this, Posts);

    var _this = _possibleConstructorReturn(this, (Posts.__proto__ || Object.getPrototypeOf(Posts)).call(this, props));

    _this.state = { posts: [], loading: true };
    return _this;
  }

  _createClass(Posts, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getPosts();
    }
  }, {
    key: "getPosts",
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var res, data, posts;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return fetch(FIREBASE_FUNCTION, {
                  method: "POST",
                  body: JSON.stringify({
                    apiKey: this.props.apiKey
                  })
                });

              case 2:
                res = _context.sent;
                _context.next = 5;
                return res.json();

              case 5:
                data = _context.sent;
                posts = JSON.parse(data.body);

                if (posts.length > 0) {
                  this.setState({ posts: posts, loading: false });
                } else {
                  this.setState({
                    loading: false
                  });
                }

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getPosts() {
        return _ref.apply(this, arguments);
      }

      return getPosts;
    }()
  }, {
    key: "render",
    value: function render() {
      var content = void 0;

      if (this.state.loading) {
        content = React.createElement(
          Loading,
          null,
          React.createElement("div", null),
          React.createElement("div", null),
          React.createElement("div", null),
          React.createElement("div", null)
        );
      } else if (!this.state.loading && this.state.posts.length == 0) {
        content = React.createElement(
          "div",
          null,
          "No updates found."
        );
      } else {
        content = React.createElement(
          PostsWrapper,
          null,
          React.createElement(
            Tabs,
            { sticky: true },
            React.createElement(
              Tab,
              { className: "active" },
              "Changelog"
            ),
            React.createElement(
              Tab,
              null,
              "Roadmap"
            )
          ),
          this.state.posts.length > 0 && React.createElement(
            Timeline,
            null,
            this.state.posts.map(function (post) {
              return React.createElement(Post, {
                key: post.slug,
                title: post.title,
                content: post.content,
                date: post.createdOn,
                type: post.type.value
              });
            })
          )
        );
      }

      return React.createElement(
        ThemeProvider,
        { theme: theme },
        content
      );
    }
  }]);

  return Posts;
}(React.Component);

export default Posts;